﻿<Project Sdk="Microsoft.NET.Sdk.Web">

    <PropertyGroup>
        <Version>1.0.0</Version>
        <Platforms>AnyCPU</Platforms>
    </PropertyGroup>

    <PropertyGroup>
        <TargetFramework>net6.0</TargetFramework>
        <TypeScriptCompileBlocked>true</TypeScriptCompileBlocked>
        <TypeScriptToolsVersion>Latest</TypeScriptToolsVersion>
        <IsPackable>false</IsPackable>
        <SpaRoot>ClientApp\</SpaRoot>
        <DefaultItemExcludes>$(DefaultItemExcludes);$(SpaRoot)node_modules\**</DefaultItemExcludes>
        <UserSecretsId>19735118-440a-4412-9eff-e9ab2a6544a5</UserSecretsId>
        <LangVersion>10</LangVersion>
        <Nullable>warnings</Nullable>
        <Configurations>Debug;Release</Configurations>
    </PropertyGroup>

    <ItemGroup>
        <PackageReference Include="Fido2.AspNet" Version="2.0.2" />
        <PackageReference Include="GraphQL" Version="5.3.0" />
        <PackageReference Include="GraphQL.Authorization" Version="5.0.0" />
        <PackageReference Include="GraphQL.DataLoader" Version="5.3.0" />
        <PackageReference Include="GraphQL.MemoryCache" Version="5.3.0" />
        <PackageReference Include="GraphQL.MicrosoftDI" Version="5.3.0" />
        <PackageReference Include="GraphQL.Server.Core" Version="5.2.1" />
        <PackageReference Include="GraphQL.Server.Transports.AspNetCore" Version="6.1.0" />
        <PackageReference Include="GraphQL.Server.Ui.Playground" Version="6.1.0" />
        <PackageReference Include="GraphQL.SystemTextJson" Version="5.3.0" />
        <PackageReference Include="Microsoft.AspNetCore.ApiAuthorization.IdentityServer" Version="6.0.6" />
        <PackageReference Include="Microsoft.AspNetCore.Diagnostics.EntityFrameworkCore" Version="6.0.6" />
        <PackageReference Include="Microsoft.AspNetCore.Identity.EntityFrameworkCore" Version="6.0.6" />
        <PackageReference Include="Microsoft.AspNetCore.Identity.UI" Version="6.0.6" />
        <PackageReference Include="Microsoft.AspNetCore.SpaServices" Version="5.0.0-preview.8.20414.8" />
        <PackageReference Include="Microsoft.AspNetCore.SpaServices.Extensions" Version="6.0.6" />
        <PackageReference Include="Microsoft.EntityFrameworkCore.Relational" Version="6.0.6" />
        <PackageReference Include="Microsoft.EntityFrameworkCore.SqlServer" Version="6.0.6" />
        <PackageReference Include="Microsoft.EntityFrameworkCore.Tools" Version="6.0.6">
            <PrivateAssets>all</PrivateAssets>
            <IncludeAssets>runtime; build; native; contentfiles; analyzers; buildtransitive</IncludeAssets>
        </PackageReference>
        <PackageReference Include="Newtonsoft.Json" Version="13.0.1" />
        <PackageReference Include="Pomelo.EntityFrameworkCore.MySql" Version="6.0.1" />
        <PackageReference Include="SendGrid" Version="9.28.0" />
        <PackageReference Include="Stripe.net" Version="39.119.0" />
    </ItemGroup>

    <ItemGroup>
        <!-- Don't publish the SPA source files, but do show them in the project files list -->
        <Content Remove="$(SpaRoot)**" />
        <Content Include="ClientApp\package.json" />
        <Content Include="ClientApp\public\.well-known\assetlinks.json" />
        <Content Include="ClientApp\public\icon-192-maskable.png" />
        <Content Include="ClientApp\public\icon-192.png" />
        <Content Include="ClientApp\public\icon-512-maskable.png" />
        <Content Include="ClientApp\public\icon-512.png" />
        <Content Include="ClientApp\public\manifest.json" />
        <Content Include="ClientApp\src\.prettierrc.json" />
        <Content Include="ClientApp\src\components\common\dataDisplay\Icon.js" />
        <Content Include="ClientApp\src\components\common\dataDisplay\IconButton.js" />
        <Content Include="ClientApp\src\components\common\dataDisplay\NoImagePlaceholder.js" />
        <Content Include="ClientApp\src\components\common\dataDisplay\Tag.js" />
        <Content Include="ClientApp\src\components\common\dataEntry\SearchBar.js" />
        <Content Include="ClientApp\src\components\common\dataEntry\GroupSearchBar.js" />
        <Content Include="ClientApp\src\components\common\feedback\CustomSnackbar.js" />
        <Content Include="ClientApp\src\components\common\layout\ContentContainer.js" />
        <Content Include="ClientApp\src\components\common\passwordComponents\PasswordRatingInCard.js" />
        <Content Include="ClientApp\src\components\common\passwordComponents\PasswordsContainer.js" />
        <Content Include="ClientApp\src\components\common\translation\translation.json" />
        <Content Include="ClientApp\src\components\landingpages\ActivateAccount.js" />
        <Content Include="ClientApp\src\config.json" />
        <Content Include="ClientApp\src\contexts\ExtensionContext.js" />
        <Content Include="ClientApp\src\contexts\OfflineStatusContext.js" />
        <Content Include="ClientApp\src\contexts\DrawerContext.js" />
        <Content Include="ClientApp\src\contexts\LoginContext.js" />
        <Content Include="ClientApp\src\hooks\modalHook.js" />
        <Content Include="ClientApp\src\htmlColor.json" />
        <Content Include="ClientApp\src\managers\apiManager.js" />
        <Content Include="ClientApp\src\managers\cryptoManager.js" />
        <Content Include="ClientApp\src\managers\fragmentManager.js" />
        <Content Include="ClientApp\src\managers\localStorageManager.js" />
        <Content Include="ClientApp\src\types\PasswordType.js" />
        <Content Remove="ClientApp\src\resources\**" />
        <Content Update="xunit.runner.json">
            <CopyToPublishDirectory>Never</CopyToPublishDirectory>
        </Content>
        <Content Remove="ClientApp\build\**" />
    </ItemGroup>

    <ItemGroup>
        <ProjectReference Include="..\VaulteronDatabase\VaulteronDatabase.csproj" />
        <ProjectReference Include="..\VaulteronUtilities\VaulteronUtilities.csproj" />
    </ItemGroup>

    <ItemGroup>
        <Compile Update="Queries\PasswordQueries.xaml.cs">
            <SubType>Code</SubType>
        </Compile>
        <Compile Remove="ClientApp\src\resources\**" />
        <Compile Remove="ClientApp\build\**" />
    </ItemGroup>

    <ItemGroup>
        <_ContentIncludedByDefault Remove="ClientApp\src\components\user\package.json" />
        <_ContentIncludedByDefault Remove="ClientApp\src\components\dashboard\package.json" />
        <_ContentIncludedByDefault Remove="ClientApp\src\components\profile\package.json" />
        <_ContentIncludedByDefault Remove="ClientApp\build\asset-manifest.json" />
        <_ContentIncludedByDefault Remove="ClientApp\build\manifest.json" />
    </ItemGroup>

    <ItemGroup>
        <EmbeddedResource Remove="ClientApp\src\resources\**" />
        <EmbeddedResource Remove="ClientApp\build\**" />
    </ItemGroup>

    <ItemGroup>
        <None Remove="ClientApp\src\resources\**" />
        <None Remove="ClientApp\build\**" />
        <None Remove="ClientApp\.eslintcache" />
    </ItemGroup>

    <ItemGroup Condition=" '$(Configuration)' == 'RELEASE' ">
        <None Update="xunit.runner.json">
            <CopyToOutputDirectory>PreserveNewest</CopyToOutputDirectory>
        </None>
    </ItemGroup>

    <ItemGroup>
      <TypeScriptCompile Include="ClientApp\src\graphql\generated.ts" />
    </ItemGroup>


    <Target Name="DebugEnsureNodeEnv" BeforeTargets="Build" Condition=" '$(Configuration)' == 'Debug' And !Exists('$(SpaRoot)node_modules') ">
        <!-- Ensure Node.js is installed -->
        <Exec Command="node --version" ContinueOnError="true">
            <Output TaskParameter="ExitCode" PropertyName="ErrorCode" />
        </Exec>
        <Error Condition="'$(ErrorCode)' != '0'" Text="Node.js is required to build and run this project. To continue, please install Node.js from https://nodejs.org/, and then restart your command prompt or IDE." />
        <Message Importance="high" Text="Restoring dependencies using 'yarn'. This may take several minutes..." />
        <Exec WorkingDirectory="$(SpaRoot)" Command="yarn install" />
    </Target>

    <Target Name="PublishRunWebpack" AfterTargets="ComputeFilesToPublish">
        <!-- As part of publishing, ensure the JS resources are freshly built in production mode -->
        <Exec WorkingDirectory="$(SpaRoot)" Command="yarn install" />
        <Exec WorkingDirectory="$(SpaRoot)" Command="yarn run build" />

        <!-- Include the newly-built files in the publish output -->
        <ItemGroup>
            <DistFiles Include="$(SpaRoot)build\**" />
            <ResolvedFileToPublish Include="@(DistFiles->'%(FullPath)')" Exclude="@(ResolvedFileToPublish)">
                <RelativePath>%(DistFiles.Identity)</RelativePath>
                <CopyToPublishDirectory>PreserveNewest</CopyToPublishDirectory>
            </ResolvedFileToPublish>
        </ItemGroup>
    </Target>

    <ProjectExtensions>
        <VisualStudio>
            <UserProperties appsettings_1json__JsonSchema="" />
        </VisualStudio>
    </ProjectExtensions>

</Project>
